/* ===========================================================================
                      Backtracking: COMBINATIONS
Combinations are dispositions, where the order is NOT significant. Recall that
in the dispositions the order is significant. The combinations of 'b over d'
are the different SETS (not sequences) of the b elements taken in groups of
cardinality d. The b elements are assumed to be: 1,...,b.
The combinations will be presented in lexicographic order, that is,
a1,...,ad is before b1,...,bd iff there exists k, 0<=k<d, such that:
a1 = b1, ..., ak = bk, ak+1 < bk+1.
=========================================================================== */
#include <iostream.h>
const int b=4;  // ------- b and d non negative
const int d=2;  // ------- b is not smaller than d
int A[d];  int id=0;

void printar(int A[], int size)
{for (int i=0; i<size; i++) {cout <<A[i]<<" ";} }

void generate()
{int ib=1;
do {// -------- For id==0 the first element is always ok.
    // -------- 'increasing' dispositions: see the > below.
    if ((id==0) || (ib > A[id-1]))
       {A[id]=ib; id=id+1;
       if (id==d) {printar(A,d); cout << "\n";} else generate();
       id=id-1;};
    ib=ib+1;}
while (ib<b+1);}

void main() {generate(); cout << "\n";}
/* input:              output:
------------------------------------------------------------------------------
                       1 2
                       1 3
                       1 4
                       2 3
                       2 4
                       3 4
--------------------------------------------------------------------------- */